

#include "Status.h"

#define CASE(_status) case _status: return #_status 
    
const char* QCC_StatusText(QStatus status)
{
    switch (status) {
        CASE(ER_OK);
        CASE(ER_FAIL);
        CASE(ER_UTF_CONVERSION_FAILED);
        CASE(ER_BUFFER_TOO_SMALL);
        CASE(ER_OS_ERROR);
        CASE(ER_OUT_OF_MEMORY);
        CASE(ER_SOCKET_BIND_ERROR);
        CASE(ER_INIT_FAILED);
        CASE(ER_WOULDBLOCK);
        CASE(ER_NOT_IMPLEMENTED);
        CASE(ER_TIMEOUT);
        CASE(ER_SOCK_OTHER_END_CLOSED);
        CASE(ER_BAD_ARG_1);
        CASE(ER_BAD_ARG_2);
        CASE(ER_BAD_ARG_3);
        CASE(ER_BAD_ARG_4);
        CASE(ER_BAD_ARG_5);
        CASE(ER_BAD_ARG_6);
        CASE(ER_BAD_ARG_7);
        CASE(ER_BAD_ARG_8);
        CASE(ER_INVALID_ADDRESS);
        CASE(ER_INVALID_DATA);
        CASE(ER_READ_ERROR);
        CASE(ER_WRITE_ERROR);
        CASE(ER_OPEN_FAILED);
        CASE(ER_PARSE_ERROR);
        CASE(ER_END_OF_DATA);
        CASE(ER_CONN_REFUSED);
        CASE(ER_BAD_ARG_COUNT);
        CASE(ER_WARNING);
        CASE(ER_COMMON_ERRORS);
        CASE(ER_STOPPING_THREAD);
        CASE(ER_ALERTED_THREAD);
        CASE(ER_XML_MALFORMED);
        CASE(ER_AUTH_FAIL);
        CASE(ER_AUTH_USER_REJECT);
        CASE(ER_NO_SUCH_ALARM);
        CASE(ER_TIMER_FALLBEHIND);
        CASE(ER_SSL_ERRORS);
        CASE(ER_SSL_INIT);
        CASE(ER_SSL_CONNECT);
        CASE(ER_SSL_VERIFY);
        CASE(ER_EXTERNAL_THREAD);
        CASE(ER_CRYPTO_ERROR);
        CASE(ER_CRYPTO_TRUNCATED);
        CASE(ER_CRYPTO_KEY_UNAVAILABLE);
        CASE(ER_BAD_HOSTNAME);
        CASE(ER_CRYPTO_KEY_UNUSABLE);
        CASE(ER_EMPTY_KEY_BLOB);
        CASE(ER_CORRUPT_KEYBLOB);
        CASE(ER_INVALID_KEY_ENCODING);
        CASE(ER_DEAD_THREAD);
        CASE(ER_THREAD_RUNNING);
        CASE(ER_THREAD_STOPPING);
        CASE(ER_BAD_STRING_ENCODING);
        CASE(ER_CRYPTO_INSUFFICIENT_SECURITY);
        CASE(ER_CRYPTO_ILLEGAL_PARAMETERS);
        CASE(ER_CRYPTO_HASH_UNINITIALIZED);
        CASE(ER_THREAD_NO_WAIT);
        CASE(ER_TIMER_EXITING);
        CASE(ER_INVALID_GUID);
        CASE(ER_NONE);
        CASE(ER_BUS_ERRORS);
        CASE(ER_BUS_READ_ERROR);
        CASE(ER_BUS_WRITE_ERROR);
        CASE(ER_BUS_BAD_VALUE_TYPE);
        CASE(ER_BUS_BAD_HEADER_FIELD);
        CASE(ER_BUS_BAD_SIGNATURE);
        CASE(ER_BUS_BAD_OBJ_PATH);
        CASE(ER_BUS_BAD_MEMBER_NAME);
        CASE(ER_BUS_BAD_INTERFACE_NAME);
        CASE(ER_BUS_BAD_ERROR_NAME);
        CASE(ER_BUS_BAD_BUS_NAME);
        CASE(ER_BUS_NAME_TOO_LONG);
        CASE(ER_BUS_BAD_LENGTH);
        CASE(ER_BUS_BAD_VALUE);
        CASE(ER_BUS_BAD_HDR_FLAGS);
        CASE(ER_BUS_BAD_BODY_LEN);
        CASE(ER_BUS_BAD_HEADER_LEN);
        CASE(ER_BUS_UNKNOWN_SERIAL);
        CASE(ER_BUS_UNKNOWN_PATH);
        CASE(ER_BUS_UNKNOWN_INTERFACE);
        CASE(ER_BUS_ESTABLISH_FAILED);
        CASE(ER_BUS_UNEXPECTED_SIGNATURE);
        CASE(ER_BUS_INTERFACE_MISSING);
        CASE(ER_BUS_PATH_MISSING);
        CASE(ER_BUS_MEMBER_MISSING);
        CASE(ER_BUS_REPLY_SERIAL_MISSING);
        CASE(ER_BUS_ERROR_NAME_MISSING);
        CASE(ER_BUS_INTERFACE_NO_SUCH_MEMBER);
        CASE(ER_BUS_NO_SUCH_OBJECT);
        CASE(ER_BUS_OBJECT_NO_SUCH_MEMBER);
        CASE(ER_BUS_OBJECT_NO_SUCH_INTERFACE);
        CASE(ER_BUS_NO_SUCH_INTERFACE);
        CASE(ER_BUS_MEMBER_NO_SUCH_SIGNATURE);
        CASE(ER_BUS_NOT_NUL_TERMINATED);
        CASE(ER_BUS_NO_SUCH_PROPERTY);
        CASE(ER_BUS_SET_WRONG_SIGNATURE);
        CASE(ER_BUS_PROPERTY_VALUE_NOT_SET);
        CASE(ER_BUS_PROPERTY_ACCESS_DENIED);
        CASE(ER_BUS_NO_TRANSPORTS);
        CASE(ER_BUS_BAD_TRANSPORT_ARGS);
        CASE(ER_BUS_NO_ROUTE);
        CASE(ER_BUS_NO_ENDPOINT);
        CASE(ER_BUS_BAD_SEND_PARAMETER);
        CASE(ER_BUS_UNMATCHED_REPLY_SERIAL);
        CASE(ER_BUS_BAD_SENDER_ID);
        CASE(ER_BUS_TRANSPORT_NOT_STARTED);
        CASE(ER_BUS_EMPTY_MESSAGE);
        CASE(ER_BUS_NOT_OWNER);
        CASE(ER_BUS_SET_PROPERTY_REJECTED);
        CASE(ER_BUS_CONNECT_FAILED);
        CASE(ER_BUS_REPLY_IS_ERROR_MESSAGE);
        CASE(ER_BUS_NOT_AUTHENTICATING);
        CASE(ER_BUS_NO_LISTENER);
        CASE(ER_BUS_BT_TRANSPORT_ERROR);
        CASE(ER_BUS_NOT_ALLOWED);
        CASE(ER_BUS_WRITE_QUEUE_FULL);
        CASE(ER_BUS_ENDPOINT_CLOSING);
        CASE(ER_BUS_INTERFACE_MISMATCH);
        CASE(ER_BUS_MEMBER_ALREADY_EXISTS);
        CASE(ER_BUS_PROPERTY_ALREADY_EXISTS);
        CASE(ER_BUS_IFACE_ALREADY_EXISTS);
        CASE(ER_BUS_ERROR_RESPONSE);
        CASE(ER_BUS_BAD_XML);
        CASE(ER_BUS_BAD_CHILD_PATH);
        CASE(ER_BUS_OBJ_ALREADY_EXISTS);
        CASE(ER_BUS_OBJ_NOT_FOUND);
        CASE(ER_BUS_CANNOT_EXPAND_MESSAGE);
        CASE(ER_BUS_NOT_COMPRESSED);
        CASE(ER_BUS_ALREADY_CONNECTED);
        CASE(ER_BUS_NOT_CONNECTED);
        CASE(ER_BUS_ALREADY_LISTENING);
        CASE(ER_BUS_KEY_UNAVAILABLE);
        CASE(ER_BUS_TRUNCATED);
        CASE(ER_BUS_KEY_STORE_NOT_LOADED);
        CASE(ER_BUS_NO_AUTHENTICATION_MECHANISM);
        CASE(ER_BUS_BUS_ALREADY_STARTED);
        CASE(ER_BUS_BUS_NOT_STARTED);
        CASE(ER_BUS_KEYBLOB_OP_INVALID);
        CASE(ER_BUS_INVALID_HEADER_CHECKSUM);
        CASE(ER_BUS_MESSAGE_NOT_ENCRYPTED);
        CASE(ER_BUS_INVALID_HEADER_SERIAL);
        CASE(ER_BUS_TIME_TO_LIVE_EXPIRED);
        CASE(ER_BUS_HDR_EXPANSION_INVALID);
        CASE(ER_BUS_MISSING_COMPRESSION_TOKEN);
        CASE(ER_BUS_NO_PEER_GUID);
        CASE(ER_BUS_MESSAGE_DECRYPTION_FAILED);
        CASE(ER_BUS_SECURITY_FATAL);
        CASE(ER_BUS_KEY_EXPIRED);
        CASE(ER_BUS_CORRUPT_KEYSTORE);
        CASE(ER_BUS_NO_CALL_FOR_REPLY);
        CASE(ER_BUS_NOT_A_COMPLETE_TYPE);
        CASE(ER_BUS_POLICY_VIOLATION);
        CASE(ER_BUS_NO_SUCH_SERVICE);
        CASE(ER_BUS_TRANSPORT_NOT_AVAILABLE);
        CASE(ER_BUS_INVALID_AUTH_MECHANISM);
        CASE(ER_BUS_KEYSTORE_VERSION_MISMATCH);
        CASE(ER_BUS_BLOCKING_CALL_NOT_ALLOWED);
        CASE(ER_BUS_SIGNATURE_MISMATCH);
        CASE(ER_BUS_STOPPING);
        CASE(ER_BUS_METHOD_CALL_ABORTED);
        CASE(ER_BUS_CANNOT_ADD_INTERFACE);
        CASE(ER_BUS_CANNOT_ADD_HANDLER);
        CASE(ER_BUS_KEYSTORE_NOT_LOADED);
        CASE(ER_BUS_NO_SUCH_HANDLE);
        CASE(ER_BUS_HANDLES_NOT_ENABLED);
        CASE(ER_BUS_HANDLES_MISMATCH);
        CASE(ER_BT_MAX_CONNECTIONS_USED);
        CASE(ER_BUS_NO_SESSION);
        CASE(ER_BUS_ELEMENT_NOT_FOUND);
        CASE(ER_BUS_NOT_A_DICTIONARY);
        CASE(ER_BUS_WAIT_FAILED);
        CASE(ER_BUS_BAD_SESSION_OPTS);
        CASE(ER_BUS_CONNECTION_REJECTED);
        CASE(ER_DBUS_REQUEST_NAME_REPLY_PRIMARY_OWNER);
        CASE(ER_DBUS_REQUEST_NAME_REPLY_IN_QUEUE);
        CASE(ER_DBUS_REQUEST_NAME_REPLY_EXISTS);
        CASE(ER_DBUS_REQUEST_NAME_REPLY_ALREADY_OWNER);
        CASE(ER_DBUS_RELEASE_NAME_REPLY_RELEASED);
        CASE(ER_DBUS_RELEASE_NAME_REPLY_NON_EXISTENT);
        CASE(ER_DBUS_RELEASE_NAME_REPLY_NOT_OWNER);
        CASE(ER_DBUS_START_REPLY_ALREADY_RUNNING);
        CASE(ER_ALLJOYN_BINDSESSIONPORT_REPLY_ALREADY_EXISTS);
        CASE(ER_ALLJOYN_BINDSESSIONPORT_REPLY_FAILED);
        CASE(ER_ALLJOYN_JOINSESSION_REPLY_NO_SESSION);
        CASE(ER_ALLJOYN_JOINSESSION_REPLY_UNREACHABLE);
        CASE(ER_ALLJOYN_JOINSESSION_REPLY_CONNECT_FAILED);
        CASE(ER_ALLJOYN_JOINSESSION_REPLY_REJECTED);
        CASE(ER_ALLJOYN_JOINSESSION_REPLY_BAD_SESSION_OPTS);
        CASE(ER_ALLJOYN_JOINSESSION_REPLY_FAILED);
        CASE(ER_ALLJOYN_LEAVESESSION_REPLY_NO_SESSION);
        CASE(ER_ALLJOYN_LEAVESESSION_REPLY_FAILED);
        CASE(ER_ALLJOYN_ADVERTISENAME_REPLY_ALREADY_ADVERTISING);
        CASE(ER_ALLJOYN_ADVERTISENAME_REPLY_FAILED);
        CASE(ER_ALLJOYN_CANCELADVERTISENAME_REPLY_FAILED);
        CASE(ER_ALLJOYN_FINDADVERTISEDNAME_REPLY_ALREADY_DISCOVERING);
        CASE(ER_ALLJOYN_FINDADVERTISEDNAME_REPLY_FAILED);
        CASE(ER_ALLJOYN_CANCELFINDADVERTISEDNAME_REPLY_FAILED);
        CASE(ER_BUS_UNEXPECTED_DISPOSITION);
        CASE(ER_BUS_INTERFACE_ACTIVATED);
        CASE(ER_ALLJOYN_UNBINDSESSIONPORT_REPLY_BAD_PORT);
        CASE(ER_ALLJOYN_UNBINDSESSIONPORT_REPLY_FAILED);
        CASE(ER_ALLJOYN_BINDSESSIONPORT_REPLY_INVALID_OPTS);
        CASE(ER_ALLJOYN_JOINSESSION_REPLY_ALREADY_JOINED);
        CASE(ER_BUS_SELF_CONNECT);
        CASE(ER_BUS_SECURITY_NOT_ENABLED);
        CASE(ER_BUS_LISTENER_ALREADY_SET);
        CASE(ER_BUS_PEER_AUTH_VERSION_MISMATCH);
        CASE(ER_ALLJOYN_SETLINKTIMEOUT_REPLY_NOT_SUPPORTED);
        CASE(ER_ALLJOYN_SETLINKTIMEOUT_REPLY_NO_DEST_SUPPORT);
        CASE(ER_ALLJOYN_SETLINKTIMEOUT_REPLY_FAILED);
        CASE(ER_ALLJOYN_ACCESS_PERMISSION_WARNING);
        CASE(ER_ALLJOYN_ACCESS_PERMISSION_ERROR);
        CASE(ER_BUS_DESTINATION_NOT_AUTHENTICATED);
        CASE(ER_BUS_ENDPOINT_REDIRECTED);
    default:
        return "<unknown>";
    }
}
